accounts/urls.py
from django.urls import path
from django.contrib.auth.views import LoginView, LogoutView
from accounts.views import signup

urlpatterns = [
    path("login/", LoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

expenses/urls.py
from django.contrib import admin
from django.urls import path, include, reverse_lazy
from django.views.generic.base import RedirectView


urlpatterns = [
    path("admin/", admin.site.urls),
    path("receipts/", include("receipts.urls")),
    path("", RedirectView.as_view(url=reverse_lazy("home"))),
    path("accounts/", include("accounts.urls")),
]

receipts/urls.py
from django.urls import path
from receipts.views import (
    ReceiptListView,
    ReceiptCreateView,
    ExpenseCategoryListView,
    AccountListView,
    ExpenseCategoryCreateView,
    AccountCreateView,
)

urlpatterns = [
    path("", ReceiptListView.as_view(), name="home"),
    path("create/", ReceiptCreateView.as_view(), name="create_receipt"),
    path(
        "categories/",
        ExpenseCategoryListView.as_view(),
        name="list_categories",
    ),
    path("accounts/", AccountListView.as_view(), name="list_accounts"),
    path(
        "categories/create/",
        ExpenseCategoryCreateView.as_view(),
        name="create_category",
    ),
    path(
        "accounts/create/", AccountCreateView.as_view(), name="create_account"
    ),
]

accounts/models.py
from django.db import models

# Create your models here.

receipts/models.py
from django.db import models
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL

# Create your models here.


class ExpenseCategory(models.Model):
    name = models.CharField(max_length=50)
    owner = models.ForeignKey(
        USER_MODEL,
        related_name="categories",
        on_delete=models.CASCADE,
    )

    def __str__(self):
        return self.name


class Account(models.Model):
    name = models.CharField(max_length=100)
    number = models.CharField(max_length=20)
    owner = models.ForeignKey(
        USER_MODEL,
        related_name="accounts",
        on_delete=models.CASCADE,
    )

    def __str__(self):
        return self.name


class Receipt(models.Model):
    vendor = models.CharField(max_length=200)
    total = models.DecimalField(max_digits=10, decimal_places=3)
    tax = models.DecimalField(max_digits=10, decimal_places=3)
    date = models.DateTimeField()
    purchaser = models.ForeignKey(
        USER_MODEL,
        related_name="receipts",
        on_delete=models.CASCADE,
    )
    category = models.ForeignKey(
        "ExpenseCategory",
        related_name="receipts",
        on_delete=models.CASCADE,
    )
    account = models.ForeignKey(
        "Account",
        related_name="receipts",
        on_delete=models.CASCADE,
        null=True,
    )

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.forms import UserCreationForm

# from django.contrib.auth.models import User
from django.contrib.auth import login


def signup(request):
    # POST
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            user = form.save()
            # username = request.POST.get("username")
            # password = request.POST.get("password1")
            # user = User.objects.create_user(
            #     username=username, password=password
            # )
            login(request, user)
            return redirect("home")
    # GET

    else:
        form = UserCreationForm()
    return render(request, "registration/signup.html", {"form": form})

receipts/views.py
from django.shortcuts import redirect
from django.views.generic import ListView, CreateView
from receipts.models import Receipt, Account, ExpenseCategory
from django.contrib.auth.mixins import LoginRequiredMixin

# Create your views here.


class ReceiptListView(LoginRequiredMixin, ListView):
    model = Receipt
    template_name = "receipts/list.html"
    context_object_name = "receiptlist"

    def get_queryset(self):
        return Receipt.objects.filter(purchaser=self.request.user)


class ReceiptCreateView(LoginRequiredMixin, CreateView):
    model = Receipt
    template_name = "receipts/create.html"
    fields = [
        "vendor",
        "total",
        "tax",
        "date",
        "category",
        "account",
    ]

    def form_valid(self, form):
        item = form.save(commit=False)
        item.purchaser = self.request.user
        item.save()
        return redirect("home")


class AccountListView(LoginRequiredMixin, ListView):
    model = Account
    template_name = "accounts/list.html"

    def get_queryset(self):
        return Account.objects.filter(owner=self.request.user)


class ExpenseCategoryListView(LoginRequiredMixin, ListView):
    model = ExpenseCategory
    template_name = "categories/list.html"
    context_object_name = "expense_category_list"

    def get_queryset(self):
        return ExpenseCategory.objects.filter(owner=self.request.user)


class ExpenseCategoryCreateView(LoginRequiredMixin, CreateView):
    model = ExpenseCategory
    template_name = "categories/create.html"
    fields = [
        "name",
    ]

    def form_valid(self, form):
        item = form.save(commit=False)
        item.owner = self.request.user
        item.save()
        return redirect("list_categories")


class AccountCreateView(LoginRequiredMixin, CreateView):
    model = Account
    template_name = "accounts/create.html"
    fields = [
        "name",
        "number",
    ]

    def form_valid(self, form):
        item = form.save(commit=False)
        item.owner = self.request.user
        item.save()
        return redirect("list_accounts")

receipts/templates/accounts/create.html
{% extends 'base.html' %}

{% block main %}
    <div>
        <h1>Create Account</h1>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button>Create</button>
        </form>
    </div>
{% endblock %}

receipts/templates/accounts/list.html
{% extends "base.html" %}

{% block main %}
<h1>My Account</h1>
<table>
    <thead>
        <tr>
            <th>Name</th>
            <th>Number</th>
            <th>Number of receipts</th>
        </tr>
    </thead>
    <tbody>
        {% for cata in account_list %}
        <tr>
            <td>{{cata.name}}</td>
            <td>{{cata.number}}</td>
            <td>{{cata.receipts.all|length}}</td>
        </tr>
        {% endfor %}
    </tbody>
</table>
{% endblock main %}

receipts/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <header><nav>
        <ul>
            {% if user.is_authenticated %}
            <li><a href="{% url 'home' %}">home</a></li>
            <li><a href="{% url 'create_receipt' %}">Create Receipt</a></li>
            <li><a href="{% url 'list_categories' %}">List of Categories</a></li>
            <li><a href="{% url 'create_category' %}">create the category</a></li>
            <li><a href="{% url 'list_accounts' %}">list of accounts</a></li>
            <li><a href="{% url 'create_account' %}">create the account</a></li>
            <li><a href="{% url 'logout' %}">Logout</a></li>
            {% else %}
            <li><a href="{% url 'login' %}">Login</a></li>
            <li><a href="{% url 'signup' %}">Sign Up</a></li>
            {% endif %}
        </ul>
    </nav></header>
    <main>
        {% block main %}
        {% endblock main %}

    </main>
</body>
</html>

receipts/templates/categories/create.html
{% extends 'base.html' %}

{% block main %}
    <div>
        <h1>Create Category</h1>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button>Create</button>
        </form>
    </div>
{% endblock %}

receipts/templates/categories/list.html
{% extends "base.html" %}

{% block main %}
<h1>My category</h1>
<table>
    <thead>
        <tr>
            <th>name</th>
            <th>number of receipts</th>
        </tr>
    </thead>
    <tbody>
        {% for cata in expense_category_list %}
        <tr>
            <td>{{cata.name}}</td>
            <td>{{cata.receipts.all|length}}</td>
        </tr>
        {% endfor %}
    </tbody>
</table>
{% endblock main %}

receipts/templates/receipts/create.html
{% extends 'base.html' %}

{% block main %}
    <div>
        <h1>Create Receipt</h1>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button>Create</button>
        </form>
    </div>
{% endblock %}

receipts/templates/receipts/list.html
{% extends "base.html" %}

{% block main %}
<h1>My Receipts</h1>
<table>
    <thead>
        <tr>
            <th>Vendor</th>
            <th>Total</th>
            <th>Tax</th>
            <th>Date</th>
            <th>Category</th>
            <th>Account</th>
        </tr>
    </thead>
    <tbody>
        {% for rec in receiptlist %}
        <tr>
            <td>{{rec.vendor}}</td>
            <td>{{rec.total}}</td>
            <td>{{rec.tax}}</td>
            <td>{{rec.date|date:"m-d-Y"}}</td>
            <td>{{rec.category}}</td>
            <td>{{rec.account}}</td>
        </tr>
        {% endfor %}
    </tbody>
</table>
{% endblock main %}